from flask import render_template
from biscd import app, utils

@app.errorhandler(400)
def bad_request(error):
    return render_template('400.html', title='400', error=error), 400

@app.errorhandler(401)
def unauthorized_error(error):
    return render_template('401.html', title='401'), 401

@app.errorhandler(404)
def not_found_error(error):
    return render_template('404.html', title='404'), 404

@app.errorhandler(500)
def internal_error(error):
    write_error(error)
    return render_template('500.html', title='500'), 500

def write_error(error):
    # pylint: disable=no-member
    remote = utils.get_remote_addr()
    logline = f"{remote} {str(error)} {error.__dict__}"
    app.logger.error(logline)
