#! /bin/bash

script_dir="$(dirname $(readlink -f $0))"
app_name='biscd'
source "$script_dir/venv/bin/activate"

get_conf () {
    echo `grep -s "$1" /etc/$app_name/config.yaml "$script_dir/biscd/config_default.yaml" | cut -d ':' -f 3 | head -n 1`
}

enviroment=`get_conf 'flask_env'`
host=`get_conf 'server_host'`
port=`get_conf 'port'`

export FLASK_APP="$script_dir/runserver.py"
export FLASK_ENV="$enviroment"
export APP_NAME="$app_name"

flask run --host "$host" --port "$port"

deactivate
exit 0
